"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
const core_1 = require("@material-ui/core");
const react_1 = __importDefault(require("react"));
const Button_style_1 = require("../../components/Button/Button.style");
const theme_1 = require("../../theme");
const Button = (props) => {
    const { onClick, label, disabled, hasMaterialUIStyle, hasBackIcon, status = theme_1.EButtonStatus.primary, } = props;
    const classes = (0, Button_style_1.useStyles)(props);
    if (hasMaterialUIStyle) {
        return (react_1.default.createElement(core_1.Box, { className: classes.materialUIButtonWrapper },
            react_1.default.createElement("button", { className: classes.materialUIButton, onClick: onClick, disabled: disabled }, label)));
    }
    if (status === theme_1.EButtonStatus.link) {
        return (react_1.default.createElement(core_1.Box, { className: classes.linkWrapper },
            react_1.default.createElement("a", { className: classes.link, onClick: onClick },
                hasBackIcon && "←  ",
                label)));
    }
    if (status === theme_1.EButtonStatus.secondary) {
        return (react_1.default.createElement("button", { className: `${classes.button} ${classes.secondaryButton}`, onClick: onClick, disabled: disabled }, label));
    }
    return (react_1.default.createElement("button", { className: classes.button, onClick: onClick, disabled: disabled }, label));
};
exports.Button = Button;
//# sourceMappingURL=Button.js.map