"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceAutocomplete = void 0;
const react_1 = __importDefault(require("react"));
const Close_1 = __importDefault(require("@material-ui/icons/Close"));
const core_1 = require("@material-ui/core");
const lab_1 = require("@material-ui/lab");
const GovernanceCheckbox_1 = require("../../components/GovernanceCheckbox");
const GovernanceAutocomplete_style_1 = require("../../components/GovernanceAutocomplete/GovernanceAutocomplete.style");
const GovernanceAutocomplete = ({ title, options, handleChange, multiple, ...rest }) => {
    const classes = (0, GovernanceAutocomplete_style_1.useStyles)();
    return (react_1.default.createElement(lab_1.Autocomplete, { options: options, multiple: multiple, disableCloseOnSelect: true, renderOption: (option, { selected }) => (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(GovernanceCheckbox_1.GovernanceCheckbox, { size: "small", color: "primary", className: classes.checkbox, checked: selected }),
            option.label)), getOptionLabel: (option) => option.label, ChipProps: {
            deleteIcon: react_1.default.createElement(Close_1.default, null),
        }, onChange: (_e, value) => {
            handleChange(value);
        }, renderInput: (params) => (react_1.default.createElement(react_1.default.Fragment, null,
            title && (react_1.default.createElement(core_1.Typography, { variant: "body1", color: "textPrimary", className: classes.title }, title)),
            react_1.default.createElement(core_1.TextField, { variant: "outlined", ...params }))), ...rest }));
};
exports.GovernanceAutocomplete = GovernanceAutocomplete;
//# sourceMappingURL=GovernanceAutocomplete.js.map