"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStyles = void 0;
const core_1 = require("@material-ui/core");
const hooks_1 = require("../../hooks");
const theme_1 = require("../../theme");
const useStyles = () => {
    const widgetUniqueIdentifier = (0, hooks_1.useWidgetUniqueIdentifier)();
    const styles = (0, core_1.makeStyles)(() => ({
        dialog: () => ({
            [`& .${widgetUniqueIdentifier}MuiDialog-paper`]: {
                borderRadius: 3,
                backgroundColor: theme_1.colors.GRAY100,
                border: `2px solid ${theme_1.colors.GRAY300}`,
            },
            [`& .${widgetUniqueIdentifier}MuiDialogTitle-root`]: {
                padding: 0,
            },
        }),
        dialogTitle: {
            display: "flex",
            alignItems: "center",
            justifyContent: "space-between",
            fontSize: theme_1.EFontSize.H4,
            padding: "16px 40px",
        },
        dialogDescription: {},
        dialogContent: {
            padding: "16px 40px",
        },
        closeButton: {
            marginRight: -12,
        },
    }));
    return styles();
};
exports.useStyles = useStyles;
//# sourceMappingURL=GovernanceDialog.style.js.map