"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceDialogSelectField = void 0;
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const icons_1 = require("@material-ui/icons");
const formik_1 = require("formik");
const GovernanceDialogSelectField_style_1 = require("../../components/GovernanceDialogSelectField/GovernanceDialogSelectField.style");
const GovernanceDialogSelectField = (props) => {
    const { title, dialogTitle, required, options, wrapperClassName } = props;
    const classes = (0, GovernanceDialogSelectField_style_1.useStyles)({});
    const titleText = `${title}${required ? " *" : ""}`;
    const [isDialogOpen, setIsDialogOpen] = (0, react_1.useState)(false);
    const toggleDialogOpen = () => {
        setIsDialogOpen((open) => !open);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.Box, { className: `${classes.wrapper} ${wrapperClassName}`, onClick: toggleDialogOpen },
            title && (react_1.default.createElement(core_1.Typography, { variant: "body1", color: "textPrimary", className: classes.title }, titleText)),
            react_1.default.createElement(formik_1.Field, { className: classes.field, ...props }, ({ field, form, meta }) => {
                var _a;
                return (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(core_1.Box, { className: classes.fieldTextWrapper },
                        react_1.default.createElement(core_1.Typography, { variant: "body2" }, (_a = options === null || options === void 0 ? void 0 : options.find((option) => option.value === field.value)) === null || _a === void 0 ? void 0 : _a.primaryText),
                        react_1.default.createElement(icons_1.KeyboardArrowDown, null)),
                    react_1.default.createElement(core_1.Dialog, { open: isDialogOpen, onClose: () => {
                            setIsDialogOpen(false);
                        }, fullWidth: true, maxWidth: "sm", onClick: (e) => {
                            e.stopPropagation();
                        } },
                        react_1.default.createElement(core_1.DialogTitle, null,
                            react_1.default.createElement(core_1.Box, { className: classes.dialogTitle },
                                react_1.default.createElement(core_1.IconButton, { "aria-label": "close", onClick: () => {
                                        setIsDialogOpen(false);
                                    } },
                                    react_1.default.createElement(icons_1.Close, null)),
                                dialogTitle || titleText)),
                        react_1.default.createElement(core_1.Divider, null),
                        react_1.default.createElement(core_1.List, { className: classes.list }, options === null || options === void 0 ? void 0 : options.map((option, index) => (react_1.default.createElement(core_1.ListItem, { key: index, className: classes.listItem, button: true, onClick: () => {
                                form.setFieldValue(props.name, option.value);
                                setIsDialogOpen(false);
                            } },
                            option.icon && (react_1.default.createElement(core_1.ListItemAvatar, null,
                                react_1.default.createElement(core_1.Avatar, null, option.icon))),
                            react_1.default.createElement(core_1.ListItemText, { ...(option.primaryText && {
                                    primary: option.primaryText,
                                }), ...(option.secondaryText && {
                                    secondary: option.secondaryText,
                                }) }),
                            option.action && (react_1.default.createElement(core_1.ListItemSecondaryAction, null, option.action)))))))));
            }))));
};
exports.GovernanceDialogSelectField = GovernanceDialogSelectField;
//# sourceMappingURL=GovernanceDialogSelectField.js.map