"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceEditableValueWithTitle = void 0;
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const icons_1 = require("@material-ui/icons");
const formik_1 = require("formik");
const components_1 = require("../../components");
const GovernanceEditableValueWithTitle_style_1 = require("../../components/GovernanceEditableValueWithTitle/GovernanceEditableValueWithTitle.style");
const GovernanceEditableValueWithTitle = (props) => {
    const { title, value, topRightContent, bottomRightContent, onSave } = props;
    const classes = (0, GovernanceEditableValueWithTitle_style_1.useStyles)({});
    const [isEditing, setIsEditing] = (0, react_1.useState)(false);
    const [fieldValue, setFieldValue] = (0, react_1.useState)(value);
    const isMounted = (0, react_1.useRef)(false);
    (0, react_1.useEffect)(() => {
        if (isMounted.current) {
            onSave(fieldValue);
        }
        else {
            isMounted.current = true;
        }
    }, [fieldValue]);
    const handleEditClick = () => {
        setIsEditing(true);
    };
    const handleSaveClick = (values) => {
        setFieldValue(values[title]);
        setIsEditing(false);
    };
    return (react_1.default.createElement(core_1.Box, null, isEditing ? (react_1.default.createElement(formik_1.Formik, { initialValues: {
            [title]: fieldValue,
        }, onSubmit: handleSaveClick }, ({ handleSubmit, values }) => (react_1.default.createElement(formik_1.Form, { onSubmit: handleSubmit },
        react_1.default.createElement(components_1.GovernanceLargeField, { title: title, name: title, rightContent: react_1.default.createElement(core_1.IconButton, { className: classes.saveButton, onClick: () => {
                    handleSaveClick(values);
                } },
                react_1.default.createElement(icons_1.Save, null)), focus: true }))))) : (react_1.default.createElement(components_1.GovernanceValueWithTitle, { title: title, value: fieldValue, topRightContent: topRightContent, bottomRightContent: react_1.default.createElement(core_1.Box, null,
            bottomRightContent,
            react_1.default.createElement(core_1.IconButton, { className: classes.iconButton, onClick: handleEditClick },
                react_1.default.createElement(icons_1.Edit, null))) }))));
};
exports.GovernanceEditableValueWithTitle = GovernanceEditableValueWithTitle;
//# sourceMappingURL=GovernanceEditableValueWithTitle.js.map