"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStyles = void 0;
const core_1 = require("@material-ui/core");
const theme_1 = require("../../theme");
exports.useStyles = (0, core_1.makeStyles)((theme) => ({
    wrapper: (props) => ({
        padding: 16,
        marginBottom: 24,
        backgroundColor: theme_1.colors.GRAY100,
        border: `2px solid ${theme_1.colors.GRAY300}`,
        borderRadius: 3,
        textAlign: "left",
    }),
    title: {
        marginBottom: 28,
    },
    field: {
        width: "100%",
        border: "none",
        background: "transparent",
        outline: "none",
        color: theme.palette.text.primary,
        fontSize: theme_1.EFontSize.BODY2,
        "&::placeholder": {
            /* Chrome, Firefox, Opera, Safari 10.1+ */
            color: theme_1.colors.GRAY500,
            opacity: 1 /* Firefox */,
        },
        "&:-ms-input-placeholder": {
            /* Internet Explorer 10-11 */
            color: theme_1.colors.GRAY500,
        },
        "&::-ms-input-placeholder": {
            /* Microsoft Edge */
            color: theme_1.colors.GRAY500,
        },
    },
    rightContent: {
        marginLeft: "auto",
    },
    fieldWrapper: {
        display: "flex",
    },
}));
//# sourceMappingURL=GovernanceLargeField.style.js.map