"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceProposalListItem = void 0;
const react_1 = __importDefault(require("react"));
const core_1 = require("@material-ui/core");
const lab_1 = require("@material-ui/lab");
const GovernanceProposalListItem_style_1 = require("../../components/GovernanceProposalListItem/GovernanceProposalListItem.style");
const GovernanceStatusTag_1 = require("../../components/GovernanceStatusTag");
const objects_1 = require("@hypernetlabs/objects");
const GovernanceProposalListItem = (props) => {
    const { number, title, status, onClick } = props;
    const classes = (0, GovernanceProposalListItem_style_1.useStyles)();
    return (react_1.default.createElement(core_1.Button, { fullWidth: true, className: classes.button, onClick: onClick },
        react_1.default.createElement(core_1.Typography, { variant: "body1", className: classes.number }, number),
        status === objects_1.EProposalState.ACTIVE && (react_1.default.createElement(lab_1.Skeleton, { variant: "circle", animation: "pulse", className: classes.activePulse })),
        react_1.default.createElement(core_1.Typography, { variant: "body1", color: "textPrimary", className: classes.title }, title),
        react_1.default.createElement(core_1.Box, { className: classes.status },
            react_1.default.createElement(GovernanceStatusTag_1.GovernanceStatusTag, { status: status }))));
};
exports.GovernanceProposalListItem = GovernanceProposalListItem;
//# sourceMappingURL=GovernanceProposalListItem.js.map