"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceSearchFilter = void 0;
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const icons_1 = require("@material-ui/icons");
const GovernanceSearchFilter_style_1 = require("../../components/GovernanceSearchFilter/GovernanceSearchFilter.style");
const GovernanceSearchFilter = ({ initialValue = "", onChange, onSearchClick, onRestartClick, placeholder, disabled, title, }) => {
    const classes = (0, GovernanceSearchFilter_style_1.useStyles)();
    const [searchValue, setSearchValue] = (0, react_1.useState)(initialValue);
    const handleChange = (event) => {
        var _a, _b;
        event.persist();
        setSearchValue((_a = event === null || event === void 0 ? void 0 : event.target) === null || _a === void 0 ? void 0 : _a.value);
        onChange && onChange((_b = event === null || event === void 0 ? void 0 : event.target) === null || _b === void 0 ? void 0 : _b.value);
    };
    const onSearchIconClick = () => {
        onSearchClick(searchValue);
    };
    const onRestartIconClick = () => {
        setSearchValue("");
        onRestartClick();
    };
    return (react_1.default.createElement(core_1.Box, { className: classes.wrapper },
        react_1.default.createElement(core_1.TextField, { title: title, className: classes.textFieldWrapper, placeholder: placeholder, variant: "standard", value: searchValue, onChange: handleChange, disabled: disabled, size: "small", InputProps: {
                disableUnderline: true,
            } }),
        react_1.default.createElement(core_1.Box, { className: classes.iconClass, marginLeft: 1, onClick: onSearchIconClick },
            react_1.default.createElement(icons_1.Search, null)),
        react_1.default.createElement(core_1.Box, { className: classes.iconClass, marginLeft: 1, onClick: onRestartIconClick },
            react_1.default.createElement(icons_1.Refresh, null))));
};
exports.GovernanceSearchFilter = GovernanceSearchFilter;
//# sourceMappingURL=GovernanceSearchFilter.js.map