import React from "react";
export declare const GovernanceSideFilter: React.FC<IGovernanceSideFilterProps>;
export declare enum ESideFilterItemType {
    chip = "chip",
    rangeSlider = "rangeSlider",
    stringInput = "stringInput",
    check = "check",
    select = "select",
    dateTime = "dateTime",
    dateTimeDifference = "dateTimeDifference"
}
export interface IChipsFilterWidgetItemNew {
    label: string;
    value: string;
}
export interface IChipsFilterWidgetNew {
    chipItems?: IChipsFilterWidgetItemNew[];
    selectedItemValue?: string;
}
export interface IRangeSliderFilterWidgetNew {
    maxValue?: number;
    minValue?: number;
    selectedMaxValue?: number;
    selectedMinValue?: number;
}
export interface ISelectFilterWidgetNew {
    options?: IFilterOptionNew[];
}
export interface IDateTimePickerWidgetNew {
    hideTime?: boolean;
}
export interface IFilterOptionNew {
    label: string;
    value: any;
    subText?: string;
}
export interface IFilterItemNew {
    label: string;
    stateKey: string;
    widgetType: ESideFilterItemType;
    widgetProps?: IFilterWidgetsNew;
    defaultValue?: string | string[] | number | number[];
}
export interface IFilterWidgetsNew extends IChipsFilterWidgetNew, IRangeSliderFilterWidgetNew, ISelectFilterWidgetNew, IDateTimePickerWidgetNew {
}
export interface IAppliedFilterContainerNew {
    label: string;
    children: React.ReactNode;
}
export interface IGovernanceSideFilterProps {
    visible: boolean;
    itemsCount?: number;
    onClose: () => void;
    filterItems: Array<IFilterItemNew>;
    onFilterSubmit: (values: any) => void;
    onReset?: () => void;
}
//# sourceMappingURL=GovernanceSideFilter.d.ts.map