"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListItem = void 0;
const react_1 = __importDefault(require("react"));
const core_1 = require("@material-ui/core");
const ListItem_style_1 = require("../../components/ListItem/ListItem.style");
const ListItem = (props) => {
    const { rightContent, icon, title, description, disableDivider } = props;
    const classes = (0, ListItem_style_1.useStyles)();
    return (react_1.default.createElement(core_1.Box, { className: classes.wrapper },
        react_1.default.createElement(core_1.ListItem, { className: classes.listItem, disableGutters: true },
            icon && react_1.default.createElement(core_1.ListItemIcon, null, icon),
            react_1.default.createElement(core_1.ListItemText, { ...(title && {
                    primary: title,
                }), ...(description && {
                    primary: description,
                }) }),
            rightContent && (react_1.default.createElement(core_1.Box, { className: classes.rightContent }, rightContent))),
        !disableDivider && react_1.default.createElement(core_1.Divider, { className: classes.divider })));
};
exports.ListItem = ListItem;
//# sourceMappingURL=ListItem.js.map