"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PullPaymentList = void 0;
const objects_1 = require("@hypernetlabs/objects");
const contexts_1 = require("../../contexts");
const react_1 = __importStar(require("react"));
const components_1 = require("../../components");
const hooks_1 = require("../../hooks");
const PullPaymentList_style_1 = require("../../components/PullPaymentList/PullPaymentList.style");
const PULL_PAYMENTS_PER_PAGE = 5;
const tableColumns = [
    {
        cellValue: "Gateway",
        tableCellProps: {
            align: "left",
        },
    },
    {
        cellValue: "Payment Amount",
        tableCellProps: {
            align: "left",
        },
    },
    {
        cellValue: "Created",
        tableCellProps: {
            align: "left",
        },
    },
    {
        cellValue: "State",
        tableCellProps: {
            align: "left",
        },
    },
    {
        cellValue: "Payment ID",
        tableCellProps: {
            align: "left",
        },
        onlyVisibleInExpandedState: true,
    },
    {
        cellValue: "From",
        tableCellProps: {
            align: "left",
        },
        onlyVisibleInExpandedState: true,
    },
    {
        cellValue: "To",
        tableCellProps: {
            align: "left",
        },
        onlyVisibleInExpandedState: true,
    },
    {
        cellValue: "Payment Token",
        tableCellProps: {
            align: "left",
        },
        onlyVisibleInExpandedState: true,
    },
    {
        cellValue: "Required Stake",
        tableCellProps: {
            align: "left",
        },
        onlyVisibleInExpandedState: true,
    },
    {
        cellValue: "Amount Staked",
        tableCellProps: {
            align: "left",
        },
        onlyVisibleInExpandedState: true,
    },
    {
        cellValue: "Expiration Date",
        tableCellProps: {
            align: "left",
        },
        onlyVisibleInExpandedState: true,
    },
    {
        cellValue: "Updated",
        tableCellProps: {
            align: "left",
        },
        onlyVisibleInExpandedState: true,
    },
    {
        cellValue: "Action",
        mobileCellValue: " ",
        tableCellProps: {
            align: "left",
        },
    },
];
const PullPaymentList = (props) => {
    const { pullPayments, publicIdentifier, onAcceptPullPaymentClick, onPullFundClick, tokenInformationList, onRepairPaymentClick, } = props;
    const classes = (0, PullPaymentList_style_1.useStyles)();
    const { viewUtils, dateUtils } = (0, contexts_1.useStoreContext)();
    const { loading } = (0, hooks_1.useLinks)();
    const [page, setPage] = (0, react_1.useState)(1);
    const initialValue = [];
    const paginatedPullPayments = (0, react_1.useMemo)(() => (0, components_1.extractDataByPage)(pullPayments, PULL_PAYMENTS_PER_PAGE, page), [JSON.stringify(pullPayments), page]);
    const rows = (0, react_1.useMemo)(() => paginatedPullPayments.reduce((acc, item) => {
        acc.push([
            {
                cellValue: item.gatewayUrl,
                tableCellProps: {
                    align: "left",
                },
            },
            {
                cellValue: viewUtils.convertToEther(item.authorizedAmount),
                tableCellProps: {
                    align: "left",
                },
            },
            {
                cellValue: dateUtils.fromTimestampToUI(item.createdTimestamp),
                tableCellProps: {
                    align: "left",
                },
            },
            {
                cellValue: (react_1.default.createElement(components_1.GovernanceTag, { text: viewUtils.fromPaymentState(item.state), color: components_1.ETagColor.BLUE })),
                tableCellProps: {
                    align: "left",
                },
            },
            {
                cellValue: item.id,
                tableCellProps: {
                    align: "left",
                },
                onlyVisibleInExpandedState: true,
            },
            {
                cellValue: item.from,
                tableCellProps: {
                    align: "left",
                },
                onlyVisibleInExpandedState: true,
            },
            {
                cellValue: item.to,
                tableCellProps: {
                    align: "left",
                },
                onlyVisibleInExpandedState: true,
            },
            {
                cellValue: (react_1.default.createElement(components_1.GovernancePaymentTokenCell, { paymentTokenAddress: item.paymentToken, tokenInformationList: tokenInformationList })),
                tableCellProps: {
                    align: "left",
                },
                onlyVisibleInExpandedState: true,
            },
            {
                cellValue: viewUtils.convertToEther(item.requiredStake),
                tableCellProps: {
                    align: "left",
                },
                onlyVisibleInExpandedState: true,
            },
            {
                cellValue: viewUtils.convertToEther(item.amountStaked),
                tableCellProps: {
                    align: "left",
                },
                onlyVisibleInExpandedState: true,
            },
            {
                cellValue: dateUtils.fromTimestampToUI(item.expirationDate),
                tableCellProps: {
                    align: "left",
                },
                onlyVisibleInExpandedState: true,
            },
            {
                cellValue: dateUtils.fromTimestampToUI(item.updatedTimestamp),
                tableCellProps: {
                    align: "left",
                },
                onlyVisibleInExpandedState: true,
            },
            {
                cellValue: (react_1.default.createElement(react_1.default.Fragment, null,
                    item.state !== objects_1.EPaymentState.Finalized && (react_1.default.createElement(components_1.GovernanceButton, { size: "small", variant: "outlined", color: "primary", className: classes.actionButton, onClick: () => onRepairPaymentClick(item.id) }, "Repair")),
                    item.state === objects_1.EPaymentState.Proposed && (react_1.default.createElement(components_1.GovernanceButton, { size: "small", variant: "outlined", color: "primary", onClick: () => onAcceptPullPaymentClick(item.id) }, "Accept")),
                    publicIdentifier === item.to &&
                        item.state === objects_1.EPaymentState.Approved && (react_1.default.createElement(components_1.GovernanceButton, { size: "small", variant: "outlined", color: "secondary", onClick: () => onPullFundClick(item.id) }, "Pull Funds")))),
                tableCellProps: {
                    align: "left",
                },
            },
        ]);
        return acc;
    }, initialValue), [
        JSON.stringify(paginatedPullPayments),
        JSON.stringify(tokenInformationList),
    ]);
    if (!loading && !rows.length) {
        return (react_1.default.createElement(components_1.GovernanceEmptyState, { title: "No results!", description: "You don\u2019t have any payments yet." }));
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(components_1.GovernanceTable, { isExpandable: true, columns: tableColumns, rows: rows }),
        pullPayments.length > 0 && (react_1.default.createElement(components_1.GovernancePagination, { className: classes.pagination, customPageOptions: {
                itemsPerPage: PULL_PAYMENTS_PER_PAGE,
                totalItems: pullPayments.length,
            }, onChange: (_, page) => {
                setPage(page);
            } }))));
};
exports.PullPaymentList = PullPaymentList;
//# sourceMappingURL=PullPaymentList.js.map