"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectInput = void 0;
const core_1 = require("@material-ui/core");
const react_1 = __importDefault(require("react"));
const SelectInput_style_1 = require("../../components/SelectInput/SelectInput.style");
const SelectInput = (props) => {
    const { onChange, label, disabled, value, fullWidth, options, optionValueKey, optionLabelKey, } = props;
    const classes = (0, SelectInput_style_1.useStyles)();
    return (react_1.default.createElement(core_1.Box, { className: classes.wrapper },
        label && react_1.default.createElement("label", { className: classes.selectLabel }, label),
        react_1.default.createElement(core_1.Box, { className: classes.select },
            react_1.default.createElement("select", { className: classes.selectText, value: value, onChange: onChange, disabled: disabled, required: true },
                react_1.default.createElement("option", { value: "" }, "Choose..."), options === null || options === void 0 ? void 0 :
                options.map((option, index) => (react_1.default.createElement("option", { key: index, value: option[optionValueKey] }, option[optionLabelKey])))))));
};
exports.SelectInput = SelectInput;
//# sourceMappingURL=SelectInput.js.map