"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenSelector = void 0;
const react_1 = __importDefault(require("react"));
const components_1 = require("../../components");
const TokenSelector = (props) => {
    const { tokenSelectorOptions, selectedPaymentToken, setSelectedPaymentToken, label = "Token Selector:", } = props;
    const handleChange = (event) => {
        const selectedOption = tokenSelectorOptions === null || tokenSelectorOptions === void 0 ? void 0 : tokenSelectorOptions.find((option) => (option === null || option === void 0 ? void 0 : option.address) === event.target.value);
        setSelectedPaymentToken(selectedOption);
    };
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(components_1.SelectInput, { options: tokenSelectorOptions, label: label, value: selectedPaymentToken === null || selectedPaymentToken === void 0 ? void 0 : selectedPaymentToken.address, onChange: handleChange, optionLabelKey: "tokenName", optionValueKey: "address" })));
};
exports.TokenSelector = TokenSelector;
//# sourceMappingURL=TokenSelector.js.map