"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLayoutContext = exports.LayoutProvider = void 0;
const react_1 = __importStar(require("react"));
const react_alert_1 = require("react-alert");
const constants_1 = require("../constants");
const theme_1 = require("../theme");
const LayoutContext = (0, react_1.createContext)({});
function LayoutProvider({ children }) {
    const alert = (0, react_alert_1.useAlert)();
    const [modalWidth, setModalWidth] = (0, react_1.useState)(900);
    const [loading, setLoading] = (0, react_1.useState)(false);
    const [modalStatus, setModalStatus] = (0, react_1.useState)(theme_1.EStatusColor.IDLE);
    const closeModal = () => {
        const modalRoot = document.getElementById(constants_1.WEB_UI_MODAL_ID_SELECTOR);
        if (modalRoot != null) {
            modalRoot.innerHTML = "";
        }
    };
    const handleCoreError = (err) => {
        setLoading(false);
        let errorMessage = "";
        if ((err === null || err === void 0 ? void 0 : err.message) != null && (err === null || err === void 0 ? void 0 : err.message.includes("Nonce too high"))) {
            errorMessage =
                "Nonce too high error, try to restart your metamask from the advanced option";
        }
        else if ((err === null || err === void 0 ? void 0 : err.message) != null) {
            errorMessage = err === null || err === void 0 ? void 0 : err.message;
        }
        else {
            errorMessage = "Something went wrong!";
        }
        alert.error(errorMessage);
    };
    const initialState = {
        setModalWidth,
        modalWidth,
        setModalStatus,
        modalStatus,
        closeModal,
        loading,
        setLoading,
        handleCoreError,
    };
    return (react_1.default.createElement(LayoutContext.Provider, { value: initialState }, children));
}
exports.LayoutProvider = LayoutProvider;
const useLayoutContext = () => (0, react_1.useContext)(LayoutContext);
exports.useLayoutContext = useLayoutContext;
//# sourceMappingURL=Layout.js.map