import { ChainId, IHypernetCore, IUIData, RenderError } from "@hypernetlabs/objects";
import { IConnectorAuthorizationFlowParams, IHypernetWebUI, IRenderParams, IRenderPaymentWidgetParams, IOnboardingFlowParams, IViewUtils, IDateUtils, IProposalsWidgetParams, IProposalCreateWidgetParams, IProposalDetailWidgetParams, IRegistryListWidgetParams, IRegistryEntryListWidgetParams, IRegistryEntryDetailWidgetParams, IRegistryDetailWidgetParams } from "../../interfaces";
import { Result } from "neverthrow";
export default class HypernetWebUI implements IHypernetWebUI {
    private static instance;
    protected coreInstance: IHypernetCore;
    protected UIData: IUIData;
    protected viewUtils: IViewUtils;
    protected dateUtils: IDateUtils;
    protected governanceChainId: ChainId;
    constructor(_coreInstance: IHypernetCore, _UIData: IUIData, iframeURL: string | null, governanceChainId: number | null, debug: boolean | null);
    private _generateDomElement;
    private _removeExistedElement;
    private _bootstrapComponent;
    private _getThrowableRender;
    renderPrivateKeysModal(): Result<void, RenderError>;
    renderMetamaskWarningModal(): Result<void, RenderError>;
    renderWalletConnectWidget(config: IRenderParams): Result<void, RenderError>;
    renderWarningAlertModal(errorMessage?: string): Result<void, RenderError>;
    renderBalancesWidget(config?: IRenderParams): Result<void, RenderError>;
    renderBalancesSummaryWidget(config?: IRenderParams): Result<void, RenderError>;
    renderGatewaysWidget(config?: IRenderParams): Result<void, RenderError>;
    renderFundWidget(config?: IRenderParams): Result<void, RenderError>;
    renderWithdrawWidget(config?: IRenderParams): Result<void, RenderError>;
    renderLinksWidget(config?: IRenderParams): Result<void, RenderError>;
    renderPaymentWidget(config?: IRenderPaymentWidgetParams): Result<void, RenderError>;
    renderPublicIdentifierWidget(config?: IRenderParams): Result<void, RenderError>;
    renderStateChannelsWidget(config?: IRenderParams): Result<void, RenderError>;
    renderConnectorAuthorizationFlow(config: IConnectorAuthorizationFlowParams): Result<void, RenderError>;
    startOnboardingFlow(config: IOnboardingFlowParams): Result<void, RenderError>;
    renderProposalsWidget(config?: IProposalsWidgetParams): Result<void, RenderError>;
    renderProposalDetailWidget(config: IProposalDetailWidgetParams): Result<void, RenderError>;
    renderProposalCreateWidget(config?: IProposalCreateWidgetParams): Result<void, RenderError>;
    renderRegistryListWidget(config?: IRegistryListWidgetParams): Result<void, RenderError>;
    renderRegistryDetailWidget(config: IRegistryDetailWidgetParams): Result<void, RenderError>;
    renderRegistryEntryListWidget(config: IRegistryEntryListWidgetParams): Result<void, RenderError>;
    renderRegistryEntryDetailWidget(config: IRegistryEntryDetailWidgetParams): Result<void, RenderError>;
    renderHypertokenBalanceWidget(config?: IRenderParams): Result<void, RenderError>;
    renderVotingPowerWidget(config?: IRenderParams): Result<void, RenderError>;
    renderConnectedAccountWidget(config?: IRenderParams): Result<void, RenderError>;
}
//# sourceMappingURL=HypernetWebUI.d.ts.map