"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const objects_1 = require("@hypernetlabs/objects");
const core_1 = require("@material-ui/core");
const contexts_1 = require("../../contexts");
const formik_1 = require("formik");
const react_1 = __importStar(require("react"));
const RemoveCircleOutline_1 = __importDefault(require("@material-ui/icons/RemoveCircleOutline"));
const components_1 = require("../../components");
const CreateBatchIdentityWidget_style_1 = require("../../widgets/CreateBatchIdentityWidget/CreateBatchIdentityWidget.style");
const CreateBatchIdentityWidget = ({ onCloseCallback, registryName, currentAccountAddress, }) => {
    const classes = (0, CreateBatchIdentityWidget_style_1.useStyles)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { setLoading, handleCoreError } = (0, contexts_1.useLayoutContext)();
    const [generateRandomTokenIdSwitch, setGenerateRandomTokenIdSwitch] = (0, react_1.useState)(true);
    const [createdEntries, setCreatedEntries] = (0, react_1.useState)([]);
    const handleCreateIdentity = ({ label, recipientAddress, tokenUri, tokenId, }) => {
        setLoading(true);
        const registryEntries = [...createdEntries];
        if (label != "" && tokenId != "" && recipientAddress != "") {
            registryEntries.push(new objects_1.RegistryEntry(label, (0, objects_1.RegistryTokenId)(Number(tokenId)), (0, objects_1.EthereumAccountAddress)(recipientAddress), tokenUri, null));
        }
        coreProxy
            .createBatchRegistryEntry(registryName, registryEntries)
            .map(() => {
            setLoading(false);
            onCloseCallback();
        })
            .mapErr(handleCoreError);
    };
    const handleGenerateTokenIdSwitchChange = (setFieldValue, value) => {
        setGenerateRandomTokenIdSwitch(value);
        if (value === true) {
            setFieldValue("tokenId", Math.floor(Math.random() * 10000000000).toString());
        }
        else {
            setFieldValue("tokenId", "");
        }
    };
    const handleAddMoreEntries = (resetForm, values) => {
        setCreatedEntries((prevState) => {
            return [
                ...prevState,
                new objects_1.RegistryEntry(values.label, (0, objects_1.RegistryTokenId)(Number(values.tokenId)), (0, objects_1.EthereumAccountAddress)(values.recipientAddress), values.tokenUri, null),
            ];
        });
        resetForm({
            values: {
                tokenUri: "",
                label: "",
                recipientAddress: currentAccountAddress,
                tokenId: Math.floor(Math.random() * 10000000000).toString(),
            },
        });
    };
    const removeCreatedEntry = (index) => {
        setCreatedEntries((prevState) => {
            return [...prevState.filter((entry, entryIndex) => entryIndex !== index)];
        });
    };
    return (react_1.default.createElement(components_1.GovernanceDialog, { title: "Create Batch Identity", isOpen: true, onClose: onCloseCallback, content: react_1.default.createElement(core_1.Box, { className: classes.wrapper },
            react_1.default.createElement(core_1.Box, { className: classes.createdEntries }, createdEntries.map((registryEntry, index) => (react_1.default.createElement(core_1.Box, { key: index, display: "flex", justifyContent: "space-between" },
                react_1.default.createElement(core_1.Typography, null, registryEntry.label),
                react_1.default.createElement(core_1.Box, { onClick: () => removeCreatedEntry(index), className: classes.removeIcon },
                    react_1.default.createElement(RemoveCircleOutline_1.default, null)))))),
            react_1.default.createElement(formik_1.Formik, { initialValues: {
                    label: "",
                    recipientAddress: currentAccountAddress,
                    tokenUri: "",
                    tokenId: Math.floor(Math.random() * 10000000000).toString(),
                }, onSubmit: handleCreateIdentity }, ({ handleSubmit, values, setFieldValue, resetForm }) => {
                return (react_1.default.createElement(formik_1.Form, { onSubmit: handleSubmit },
                    react_1.default.createElement(core_1.Box, { className: classes.switchContainer },
                        react_1.default.createElement(core_1.Typography, { className: classes.switchTitle }, "Generate Random Token ID"),
                        react_1.default.createElement(components_1.GovernanceSwitch, { initialValue: generateRandomTokenIdSwitch, onChange: (value) => {
                                handleGenerateTokenIdSwitchChange(setFieldValue, value);
                            } })),
                    react_1.default.createElement(components_1.GovernanceField, { title: "Token id", name: "tokenId", type: "input", placeholder: "Enter a number for your token" }),
                    react_1.default.createElement(components_1.GovernanceField, { title: "Label", name: "label", type: "input", placeholder: "Enter a label" }),
                    react_1.default.createElement(components_1.GovernanceField, { title: "Recipient Address", name: "recipientAddress", type: "input", placeholder: "Enter the recipient address" }),
                    react_1.default.createElement(components_1.GovernanceField, { title: "Token URI", name: "tokenUri", type: "input", placeholder: "Enter the token URI" }),
                    react_1.default.createElement(core_1.Box, { className: classes.actionContainer },
                        react_1.default.createElement(components_1.GovernanceButton, { variant: "outlined", color: "primary", onClick: onCloseCallback }, "Cancel"),
                        react_1.default.createElement(components_1.GovernanceButton, { className: classes.button, variant: "contained", color: "secondary", onClick: () => handleAddMoreEntries(resetForm, values), disabled: !values.recipientAddress || !values.label }, "Add More"),
                        react_1.default.createElement(components_1.GovernanceButton, { className: classes.button, variant: "contained", color: "primary", onClick: handleSubmit, disabled: (!values.recipientAddress ||
                                !values.tokenId ||
                                !values.label) &&
                                createdEntries.length === 0 }, "Submit"))));
            })) }));
};
exports.default = CreateBatchIdentityWidget;
//# sourceMappingURL=CreateBatchIdentityWidget.js.map