"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaymentWidget = void 0;
const objects_1 = require("@hypernetlabs/objects");
const objects_2 = require("../../interfaces/objects");
const react_1 = __importDefault(require("react"));
const components_1 = require("../../components");
const hooks_1 = require("../../hooks");
const PaymentWidget = (props) => {
    const { tokenSelectorOptions, selectedPaymentToken, setSelectedPaymentToken, setCounterPartyAccount, counterPartyAccount, paymentType, setExpirationDate, setAmount, setPaymentType, setRequiredStake, paymentTypeOptions, amount, requiredStake, expirationDate, resultMessage, } = (0, hooks_1.usePayment)({ ...props });
    if ((resultMessage === null || resultMessage === void 0 ? void 0 : resultMessage.status) === objects_2.EResultStatus.SUCCESS) {
        return (react_1.default.createElement("div", null,
            react_1.default.createElement("h3", null, resultMessage.message)));
    }
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("h3", null, "Create Payment"),
        react_1.default.createElement("br", null),
        react_1.default.createElement(components_1.TextInput, { value: counterPartyAccount, onChange: (val) => {
                setCounterPartyAccount((0, objects_1.PublicIdentifier)(val));
            }, label: "public identifier", placeholder: "Enter public identifier" }),
        react_1.default.createElement("br", null),
        react_1.default.createElement(components_1.SelectInput, { value: paymentType, onChange: (event) => setPaymentType(event.target.value), options: paymentTypeOptions, optionValueKey: "type", optionLabelKey: "typeName" }),
        react_1.default.createElement("br", null),
        paymentType === objects_1.EPaymentType.Push && (react_1.default.createElement("div", null,
            react_1.default.createElement(components_1.TextInput, { value: requiredStake, onChange: setRequiredStake, label: "Required Stake:", placeholder: "Enter Required Stake" }),
            react_1.default.createElement("br", null),
            react_1.default.createElement(components_1.TokenSelector, { tokenSelectorOptions: tokenSelectorOptions, selectedPaymentToken: selectedPaymentToken, setSelectedPaymentToken: setSelectedPaymentToken }),
            react_1.default.createElement("br", null),
            react_1.default.createElement(components_1.TextInput, { value: amount, onChange: setAmount, label: "Amount:", placeholder: "Enter Amount" }),
            react_1.default.createElement("br", null),
            react_1.default.createElement(components_1.TextInput, { value: expirationDate, onChange: setExpirationDate, label: "Expiration Date:", placeholder: "Enter Expiration Date" }),
            react_1.default.createElement("br", null))),
        react_1.default.createElement("br", null),
        react_1.default.createElement("h3", null, resultMessage === null || resultMessage === void 0 ? void 0 : resultMessage.message)));
};
exports.PaymentWidget = PaymentWidget;
//# sourceMappingURL=PaymentWidget.js.map