"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const objects_1 = require("@hypernetlabs/objects");
const core_1 = require("@material-ui/core");
const contexts_1 = require("../../contexts");
const formik_1 = require("formik");
const react_1 = __importStar(require("react"));
const components_1 = require("../../components");
const StateChannelsWidget_style_1 = require("../../widgets/StateChannelsWidget/StateChannelsWidget.style");
const StateChannelsWidget = ({}) => {
    const classes = (0, StateChannelsWidget_style_1.useStyles)();
    const { coreProxy, UIData } = (0, contexts_1.useStoreContext)();
    const [stateChannels, setStateChannels] = (0, react_1.useState)([]);
    const [selectedStateChannelAddress, setSelectedStateChannelAddress] = (0, react_1.useState)((0, objects_1.EthereumContractAddress)(""));
    (0, react_1.useEffect)(() => {
        coreProxy.getActiveStateChannels().map((_stateChannels) => {
            setStateChannels(_stateChannels);
            if (_stateChannels[0] != null) {
                setSelectedStateChannelAddress(_stateChannels[0].channelAddress);
                UIData.onSelectedStateChannelChanged.next(_stateChannels[0]);
            }
        });
        coreProxy.onStateChannelCreated.subscribe((activeStateChannel) => {
            setStateChannels([...stateChannels, activeStateChannel]);
            if (stateChannels.length === 0) {
                setSelectedStateChannelAddress(activeStateChannel.channelAddress);
                UIData.onSelectedStateChannelChanged.next(activeStateChannel);
            }
        });
    }, []);
    const handleChange = (address) => {
        // Publish an event to other widgets
        setSelectedStateChannelAddress(address);
        UIData.onSelectedStateChannelChanged.next(stateChannels.find((stateChannel) => stateChannel.channelAddress === address));
    };
    return (react_1.default.createElement(core_1.Grid, { container: true, spacing: 1 },
        react_1.default.createElement(core_1.Grid, { item: true, xs: 12, sm: 12, md: 3, lg: 3, className: classes.titleContainer },
            react_1.default.createElement(core_1.Typography, { variant: "body2" }, "Hypernet Account Number")),
        react_1.default.createElement(core_1.Grid, { item: true, xs: 12, sm: 12, md: 9, lg: 9 },
            react_1.default.createElement(formik_1.Formik, { enableReinitialize: true, initialValues: {
                    stateChannel: selectedStateChannelAddress,
                }, onSubmit: () => { } }, ({ handleSubmit }) => {
                return (react_1.default.createElement(formik_1.Form, { onSubmit: handleSubmit, className: classes.form },
                    react_1.default.createElement(components_1.GovernanceDialogSelectField, { required: true, dialogTitle: "Hypernet Account Number", name: "stateChannel", type: "select", options: stateChannels.map(({ channelAddress }) => ({
                            primaryText: channelAddress,
                            value: channelAddress,
                        })), fullWidth: true, handleChange: handleChange, wrapperClassName: classes.dialogSelect })));
            }))));
};
exports.default = StateChannelsWidget;
//# sourceMappingURL=StateChannelsWidget.js.map