"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@material-ui/core");
const styles_1 = require("@material-ui/core/styles");
const theme_1 = require("../../theme");
const react_1 = __importStar(require("react"));
const useStyles = (0, styles_1.makeStyles)((theme) => (0, styles_1.createStyles)({
    root: {
        display: "flex",
        alignItems: "center",
        width: "calc(100% - 20px)",
        border: `1px solid ${theme_1.colors.GRAY300}`,
        cursor: "pointer",
    },
    iconStyle: {
        backgroundColor: "#FFFFFF",
        marginRight: 18,
    },
}));
const OptionCard = (props) => {
    const { label, value, iconSrc, iconComponent, onClick, selected, style, endComponent, } = props;
    const classes = useStyles({ selected });
    const [elevation, setElevation] = (0, react_1.useState)(2);
    return (react_1.default.createElement(core_1.Card, { elevation: 0, className: classes.root, style: style, onClick: () => {
            onClick && onClick();
        } },
        react_1.default.createElement(core_1.Radio, { style: { marginRight: 32 }, color: "primary", checked: selected }),
        iconComponent ? (react_1.default.createElement(core_1.Avatar, { alt: "Radio Icon", className: classes.iconStyle }, iconComponent)) : (react_1.default.createElement(core_1.Avatar, { alt: "Radio Icon", className: classes.iconStyle, src: iconSrc })),
        react_1.default.createElement(core_1.Box, null,
            react_1.default.createElement(core_1.Tooltip, { title: label, placement: "top" },
                react_1.default.createElement(core_1.Box, { display: "flex", alignItems: "center", style: {
                        height: 24,
                        overflow: "hidden",
                        marginRight: 8,
                    } },
                    react_1.default.createElement(core_1.Typography, { variant: "body2" }, `${label === null || label === void 0 ? void 0 : label.charAt(0).toUpperCase()}${label === null || label === void 0 ? void 0 : label.slice(1)}`)))),
        endComponent && react_1.default.createElement(core_1.Box, { marginLeft: "auto" }, endComponent)));
};
exports.default = OptionCard;
//# sourceMappingURL=OptionCard.js.map