"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WALLET_PROVIDERS = exports.WALLETCONNECT = exports.METAMASK = void 0;
const contexts_1 = require("../../contexts");
const react_1 = __importStar(require("react"));
const components_1 = require("../../components");
const core_1 = require("@material-ui/core");
const objects_1 = require("@hypernetlabs/objects");
const constants_1 = require("../../constants");
const WalletConnectWidget_style_1 = require("../../widgets/WalletConnectWidget/WalletConnectWidget.style");
const OptionCard_1 = __importDefault(require("./OptionCard"));
exports.METAMASK = {
    id: "injected",
    name: "Metamask",
    logo: constants_1.METAMASK_LOGO_IMAGE_URL,
    mobileVisible: false,
};
exports.WALLETCONNECT = {
    id: "walletconnect",
    name: "WalletConnect",
    logo: constants_1.WALLET_CONNECT_LOGO_IMAGE_URL,
    mobileVisible: true,
};
exports.WALLET_PROVIDERS = [exports.METAMASK, exports.WALLETCONNECT];
const WalletConnectWidget = (props) => {
    const classes = (0, WalletConnectWidget_style_1.useStyles)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { closeModal } = (0, contexts_1.useLayoutContext)();
    const [isMobile, setIsMobile] = (0, react_1.useState)(false);
    const [selectedWalletOption, setSelectedWalletOption] = (0, react_1.useState)(exports.METAMASK);
    const handleSubmit = () => {
        const { id } = selectedWalletOption;
        coreProxy.provideProviderId((0, objects_1.ProviderId)(id)).match(() => {
            closeModal();
        }, (err) => {
            console.error(err.message || "Err while providePrivateCredentials.");
        });
    };
    const getFilteredProviders = () => {
        if (isMobile) {
            return exports.WALLET_PROVIDERS.filter((i) => i.mobileVisible);
        }
        return exports.WALLET_PROVIDERS;
    };
    return (react_1.default.createElement(core_1.Box, { className: classes.wrapper },
        react_1.default.createElement(core_1.Box, { className: classes.titleWrapper },
            react_1.default.createElement(components_1.GovernanceTypography, { variant: "h4" }, "Please select a wallet to connect.")),
        getFilteredProviders().map((provider) => (react_1.default.createElement(OptionCard_1.default, { key: provider.id, label: provider.name, iconComponent: react_1.default.createElement("img", { width: "100%", src: provider.logo, alt: provider.name }), onClick: () => {
                setSelectedWalletOption(provider);
            }, style: { borderRadius: 3, padding: 10, marginBottom: 24 }, selected: selectedWalletOption.id === provider.id }))),
        react_1.default.createElement(core_1.Box, { className: classes.buttonWrapper },
            react_1.default.createElement(components_1.GovernanceButton, { color: "primary", variant: "contained", size: "medium", fullWidth: true, onClick: () => {
                    handleSubmit();
                } }, "Connect"))));
};
exports.default = WalletConnectWidget;
//# sourceMappingURL=WalletConnectWidget.js.map